net.i2p.router.crypto.ratchet

## Class SparseArray<E>

- java.lang.Object
- - net.i2p.router.crypto.ratchet.SparseArray<E>

- Type Parameters:
    `E` - type of objects stored in this sparse array
  All Implemented Interfaces:
    Cloneable

      class SparseArray<E>
      extends Object
      implements Cloneable

  Memory-efficient sparse array implementation for integer-to-object mappings using binary search lookup, optimized for collections with up to hundreds of items

  Note that this container keeps its mappings in an array data structure, using a binary search to find keys. The implementation is not intended to be appropriate for data structures that may contain large numbers of items. It is generally slower than a `HashMap` because lookups require a binary search, and adds and removes require inserting and deleting entries in array. For containers holding up to hundreds of items, the performance difference is less than 50%.

  To help with performance, the container includes an optimization when removing keys: instead of compacting its array immediately, it leaves the removed entry marked as deleted. The entry can then be re-used for the same key or compacted later in a single garbage collection of all removed entries. This garbage collection must be performed whenever the array needs to be grown, or when the map size or entry values are retrieved.

  It is possible to iterate over the items in this container using `keyAt(int)` and `valueAt(int)`. Iterating over keys using `keyAt(int)` with ascending values of index returns keys in ascending order. In the case of `valueAt(int)`, values corresponding to keys are returned in ascending order.

  I2P - as of 0.9.48, changed to use chars for the index, max value 65535

  Note that this container keeps its mappings in an array data structure, using a binary search to find keys. The implementation is not intended to be appropriate for data structures that may contain large numbers of items. It is generally slower than a `HashMap` because lookups require a binary search, and adds and removes require inserting and deleting entries in array. For containers holding up to hundreds of items, the performance difference is less than 50%.

  To help with performance, the container includes an optimization when removing keys: instead of compacting its array immediately, it leaves the removed entry marked as deleted. The entry can then be re-used for the same key or compacted later in a single garbage collection of all removed entries. This garbage collection must be performed whenever the array needs to be grown, or when the map size or entry values are retrieved.

  It is possible to iterate over the items in this container using `keyAt(int)` and `valueAt(int)`. Iterating over keys using `keyAt(int)` with ascending values of the index returns keys in ascending order. In the case of `valueAt(int)`, values corresponding to the keys are returned in ascending order.

  I2P - as of 0.9.48, changed to use chars for the index, max value 65535

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `SparseArray()` Creates a new SparseArray containing no mappings.
    `SparseArray(int initialCapacity)` Creates a new SparseArray containing no mappings that will not require any additional memory allocation to store the specified number of mappings.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `append(int key, E value)` Puts a key/value pair into the array, optimizing for the case where the key is greater than all existing keys in the array.
    `void` | `clear()` Removes all key-value mappings from this SparseArray.
    `SparseArray<E>` | `clone()`
    `void` | `delete(int key)` Removes the mapping from the specified key, if there was any.
    `E` | `get(int key)` Gets the Object mapped from the specified key, or `null` if no such mapping has been made.
    `E` | `get(int key, E valueIfKeyNotFound)` Gets the Object mapped from the specified key, or the specified Object if no such mapping has been made.
    `int` | `indexOfKey(int key)` Returns the index for which `keyAt(int)` would return the specified key, or a negative number if the specified key is not mapped.
    `int` | `indexOfValue(E value)` Returns an index for which `valueAt(int)` would return the specified value, or a negative number if no keys map to the specified value.
    `int` | `indexOfValueByValue(E value)` Returns an index for which `valueAt(int)` would return the specified value, or a negative number if no keys map to the specified value.
    `int` | `keyAt(int index)` Given an index in the range `0...size()-1`, returns the key from the `index`th key-value mapping that this SparseArray stores.
    `void` | `put(int key, E value)` Adds a mapping from the specified key to the specified value, replacing the previous mapping from the specified key if there was one.
    `void` | `remove(int key)` Alias for `delete(int)`.
    `void` | `removeAt(int index)` Removes the mapping at the specified index.
    `void` | `removeAtRange(int index, int size)` Remove a range of mappings as a batch.
    `E` | `removeReturnOld(int key)` Removes the mapping from the specified key, if there was any, returning the old value.
    `void` | `setValueAt(int index, E value)` Given an index in the range `0...size()-1`, sets a new value for the `index`th key-value mapping that this SparseArray stores.
    `int` | `size()` Returns the number of key-value mappings that this SparseArray currently stores.
    `String` | `toString()`
    `E` | `valueAt(int index)` Given an index in the range `0...size()-1`, returns the value from the `index`th key-value mapping that this SparseArray stores.

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### SparseArray

          public SparseArray()

      Creates a new SparseArray containing no mappings.

    - #### SparseArray

          public SparseArray(int initialCapacity)

      Creates a new SparseArray containing no mappings that will not require any additional memory allocation to store the specified number of mappings. If you supply an initial capacity of 0, the sparse array will be initialized with a light-weight representation not requiring any additional array allocations.

  - ### Method Detail

    - #### append

          public void append(int key,
                             E value)

      Puts a key/value pair into the array, optimizing for the case where the key is greater than all existing keys in the array.
      Parameters:
        `key` - 0 MIN, 65535 MAX

    - #### clear

          public void clear()

      Removes all key-value mappings from this SparseArray.

    - #### clone

          public SparseArray<E> clone()

      Overrides:
        `clone` in class `Object`

    - #### delete

          public void delete(int key)

      Removes the mapping from the specified key, if there was any.
      Parameters:
        `key` - 0 MIN, 65535 MAX

    - #### get

          public E get(int key)

      Gets the Object mapped from the specified key, or `null` if no such mapping has been made.

    - #### get

          public E get(int key,
                       E valueIfKeyNotFound)

      Gets the Object mapped from the specified key, or the specified Object if no such mapping has been made.
      Parameters:
        `key` - 0 MIN, 65535 MAX

    - #### indexOfKey

          public int indexOfKey(int key)

      Returns the index for which `keyAt(int)` would return the specified key, or a negative number if the specified key is not mapped.
      Parameters:
        `key` - 0 MIN, 65535 MAX

    - #### indexOfValue

          public int indexOfValue(E value)

      Returns an index for which `valueAt(int)` would return the specified value, or a negative number if no keys map to the specified value.

      Beware that this is a linear search, unlike lookups by key, and that multiple keys can map to the same value and this will find only one of them.

      Note also that unlike most collections' `indexOf` methods, this method compares values using `==` rather than `equals`.

    - #### indexOfValueByValue

          public int indexOfValueByValue(E value)

      Returns an index for which `valueAt(int)` would return the specified value, or a negative number if no keys map to the specified value.

      Beware that this is a linear search, unlike lookups by key, and that multiple keys can map to the same value and this will find only one of them.

      Note also that this method uses `equals` unlike `indexOfValue`.

    - #### keyAt

          public int keyAt(int index)

      Given an index in the range `0...size()-1`, returns the key from the `index`th key-value mapping that this SparseArray stores.

      The keys corresponding to indices in ascending order are guaranteed to be in ascending order, e.g., `keyAt(0)` will return the smallest key and `keyAt(size()-1)` will return the largest key.

      For indices outside of the range `0...size()-1`, a `ArrayIndexOutOfBoundsException` is thrown.

    - #### put

          public void put(int key,
                          E value)

      Adds a mapping from the specified key to the specified value, replacing the previous mapping from the specified key if there was one.
      Parameters:
        `key` - 0 MIN, 65535 MAX

    - #### remove

          public void remove(int key)

      Alias for `delete(int)`.

    - #### removeAt

          public void removeAt(int index)

      Removes the mapping at the specified index.

      For indices outside of the range `0...size()-1`, a `ArrayIndexOutOfBoundsException` is thrown.

    - #### removeAtRange

          public void removeAtRange(int index,
                                    int size)

      Remove a range of mappings as a batch.
      Parameters:
        `index` - Index to begin at
        `size` - Number of mappings to remove

        For indices outside of the range `0...size()-1`, the behavior is undefined.

    - #### removeReturnOld

          public E removeReturnOld(int key)

      Removes the mapping from the specified key, if there was any, returning the old value.
      Parameters:
        `key` - 0 MIN, 65535 MAX

    - #### setValueAt

          public void setValueAt(int index,
                                 E value)

      Given an index in the range `0...size()-1`, sets a new value for the `index`th key-value mapping that this SparseArray stores.

      For indices outside of the range `0...size()-1`, a `ArrayIndexOutOfBoundsException` is thrown.

    - #### size

          public int size()

      Returns the number of key-value mappings that this SparseArray currently stores.

    - #### toString

          public String toString()

      This implementation composes a string by iterating over its mappings. If this map contains itself as a value, the string "(this Map)" will appear in its place.

      Overrides:
        `toString` in class `Object`

    - #### valueAt

          public E valueAt(int index)

      Given an index in the range `0...size()-1`, returns the value from the `index`th key-value mapping that this SparseArray stores.

      The values corresponding to indices in ascending order are guaranteed to be associated with keys in ascending order, e.g., `valueAt(0)` will return the value associated with the smallest key and `valueAt(size()-1)` will return the value associated with the largest key.

      For indices outside of the range `0...size()-1`, a `ArrayIndexOutOfBoundsException` is thrown.